<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>ProviderRegistry.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.auth</a> &gt; <span class="el_source">ProviderRegistry.java</span></div><h1>ProviderRegistry.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.auth;

import java.util.Enumeration;
import java.util.HashMap;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import org.apache.zookeeper.server.ZooKeeperServer;

<span class="nc" id="L29">public class ProviderRegistry {</span>
<span class="fc" id="L30">    private static final Logger LOG = LoggerFactory.getLogger(ProviderRegistry.class);</span>

<span class="fc" id="L32">    private static boolean initialized = false;</span>
<span class="fc" id="L33">    private static HashMap&lt;String, AuthenticationProvider&gt; authenticationProviders =</span>
        new HashMap&lt;String, AuthenticationProvider&gt;();

    public static void initialize() {
<span class="fc" id="L37">        synchronized (ProviderRegistry.class) {</span>
<span class="pc bpc" id="L38" title="1 of 2 branches missed.">            if (initialized)</span>
<span class="nc" id="L39">                return;</span>
<span class="fc" id="L40">            IPAuthenticationProvider ipp = new IPAuthenticationProvider();</span>
<span class="fc" id="L41">            DigestAuthenticationProvider digp = new DigestAuthenticationProvider();</span>
<span class="fc" id="L42">            authenticationProviders.put(ipp.getScheme(), ipp);</span>
<span class="fc" id="L43">            authenticationProviders.put(digp.getScheme(), digp);</span>
<span class="fc" id="L44">            Enumeration&lt;Object&gt; en = System.getProperties().keys();</span>
<span class="fc bfc" id="L45" title="All 2 branches covered.">            while (en.hasMoreElements()) {</span>
<span class="fc" id="L46">                String k = (String) en.nextElement();</span>
<span class="fc bfc" id="L47" title="All 2 branches covered.">                if (k.startsWith(&quot;zookeeper.authProvider.&quot;)) {</span>
<span class="fc" id="L48">                    String className = System.getProperty(k);</span>
                    try {
<span class="fc" id="L50">                        Class&lt;?&gt; c = ZooKeeperServer.class.getClassLoader()</span>
<span class="fc" id="L51">                                .loadClass(className);</span>
<span class="fc" id="L52">                        AuthenticationProvider ap = (AuthenticationProvider) c</span>
<span class="fc" id="L53">                                .newInstance();</span>
<span class="fc" id="L54">                        authenticationProviders.put(ap.getScheme(), ap);</span>
<span class="fc" id="L55">                    } catch (Exception e) {</span>
<span class="fc" id="L56">                        LOG.warn(&quot;Problems loading &quot; + className,e);</span>
<span class="fc" id="L57">                    }</span>
                }
<span class="fc" id="L59">            }</span>
<span class="fc" id="L60">            initialized = true;</span>
<span class="pc" id="L61">        }</span>
<span class="fc" id="L62">    }</span>

    public static AuthenticationProvider getProvider(String scheme) {
<span class="fc bfc" id="L65" title="All 2 branches covered.">        if(!initialized)</span>
<span class="fc" id="L66">            initialize();</span>
<span class="fc" id="L67">        return authenticationProviders.get(scheme);</span>
    }

    public static String listProviders() {
<span class="fc" id="L71">        StringBuilder sb = new StringBuilder();</span>
<span class="fc bfc" id="L72" title="All 2 branches covered.">        for(String s: authenticationProviders.keySet()) {</span>
<span class="fc" id="L73">        sb.append(s + &quot; &quot;);</span>
<span class="fc" id="L74">}</span>
<span class="fc" id="L75">        return sb.toString();</span>
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>